package com.inca.npbusi.saset.bms_sa_rec;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.npbusi.dataimport.ImpHelper;
import com.inca.npbusi.saset.bms_sa_rec.notes.Pub_notes_hov;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.UsemmHelper;
import com.inca.pubsrv.hov.pub_custom_to_saler_hov.Pub_custom_to_saler_hov;
import java.awt.BorderLayout;
import java.math.BigDecimal;
import javax.swing.JPanel;

public class Bms_sa_rec_master extends CMasterModel {
   public Bms_sa_rec_master(CFrame var1, CMdeModel var2) {
      super(var1, "销售收款总单", var2);
   }

   public String getTablename() {
      return "bms_sa_rec_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_beforeNew() {
      String var1;
      if ((var1 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid()) != null && !var1.equals("")) {
         return super.on_beforeNew();
      } else {
         this.errorMessage("错误", "您当前登录的角色没有指定独立单元，不能录入订单！");
         return -1;
      }
   }

   protected int on_new(int var1) {
      Userruninfo var2 = ClientUserManager.getCurrentUser();
      this.setItemValue(var1, "inputmanid", var2.getUserid());
      this.setItemValue(var1, "inputmanname", var2.getUsername());
      this.setItemValue(var1, "entryid", ((Bms_sa_rec_mde)this.mdemodel).getEntryid());
      this.setItemValue(var1, "entryname", ((Bms_sa_rec_mde)this.mdemodel).getEntryname());
      this.setItemValue(var1, "usestatus", "2");
      this.setItemValue(var1, "recmethod", "3");
      this.setItemValue(var1, "initflag", "0");
      this.setItemValue(var1, "recman", var2.getUsername());
      this.setItemValue(var1, "recmanid", var2.getUserid());
      this.setItemValue(var1, "credate", NpbusiDBHelper.getSysdate());

      try {
         this.setItemValue(var1, "recmanopcode", ImpHelper.getOpcode(var2.getUsername()));
      } catch (Exception var3) {
         var3.printStackTrace();
      }

      String var4 = this.getItemValue(var1, "recmethod");
      if (!"3".equals(var4)) {
         this.getDBColumnDisplayInfo("presaleropcode").setReadonly(false);
      } else {
         this.getDBColumnDisplayInfo("presaleropcode").setReadonly(true);
      }

      return super.on_new(var1);
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3;
      if ((var3 = this.getItemValue(var1, "credate")) != null && !var3.equals("") && !var3.substring(0, 10).equals("0000-00-00")) {
         new UsemmHelper();

         try {
            if (!var2.getItemValue(var1, "usestatus").equals("1") && !UsemmHelper.checkBusidate(var3)) {
               this.warnMessage("警告", "日期" + var3 + "所在逻辑月已经结帐！");
               return -1;
            }
         } catch (Exception var6) {
            var6.printStackTrace();
            this.errorMessage("错误", var6.getMessage());
            return -1;
         }

         String var4 = this.getItemValue(var1, "recmethod");
         if (!"1".equals(var4)) {
            if ("2".equals(var4)) {
               this.errorMessage("错误", "收款类别不允许为现收，只能为预收款或收欠款");
               return -1;
            }
         } else {
            var4 = this.getItemValue(var1, "presalerid");
            var3 = this.getItemValue(var1, "presadeptid");
            String var5 = this.getItemValue(var1, "total");
            if (var4 == null || var4.equals("")) {
               this.errorMessage("错误", "预收款业务员ID不能为空!");
               return -1;
            }

            if (var3 == null || var3.equals("")) {
               this.errorMessage("错误", "预收款业务部门ID不能为空!");
               return -1;
            }

            if ((var3 = this.getItemValue(var1, "oldprerecid")) != null && !"".equals(var3)) {
               if (var5 == null || "".equals(var5) || DecimalHelper.toDec(var5).compareTo(new BigDecimal("0")) > 0) {
                  this.infoMessage("提示", "您选择了原预收款单，收款额必须为负数！");
                  return -1;
               }
            } else {
               if (var5 == null || "".equals(var5) || DecimalHelper.toDec(var5).compareTo(new BigDecimal("0")) <= 0) {
                  this.infoMessage("提示", "预收款为负数的时候,请选择勾兑原预收款单！");
                  return -1;
               }

               if (DecimalHelper.toDec(var3 = this.getItemValue(var1, "premoney")).compareTo(new BigDecimal("0")) < 0) {
                  this.infoMessage("提示", "您在进行预收款核销，细单金额不能是负数！");
                  return -1;
               }

               var4 = this.getItemValue(var1, "recexpmoney");
               if (DecimalHelper.toDec(var3).compareTo((new BigDecimal(var5)).subtract(DecimalHelper.toDec(var4))) > 0) {
                  this.infoMessage("提示", "您在进行预收款核销，细单金额不能大于收款额！");
                  return -1;
               }
            }

            if (DecimalHelper.toDec(this.mdemodel.getDetailModel().getSumdbmodel().sum("total_line").toString()).compareTo(new BigDecimal("0")) < 0) {
               this.infoMessage("提示", "您在进行预收款核销，细单的收款金额之和必须是正数！");
               return -1;
            }
         }

         if ((var4 = this.getItemValue(var1, "fmid")) == null || var4.equals("")) {
            this.setItemValue(var1, "fmid", "0");
            this.setItemValue(var1, "exchange", "1");
         }

         return super.on_checkrow(var1, var2);
      } else {
         this.errorMessage("错误", "建立日期不能为空!");
         return -1;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4;
      String var5;
      RemotesqlHelper var6;
      String var7;
      String var16;
      if (var2.equals("customid")) {
         var4 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid();
         var5 = "select settletypeid from pub_company_to_definfo where companyid=" + var3 + " and (entryid is null or entryid=" + var4 + ") order by nvl(entryid,-1) desc";
         var6 = new RemotesqlHelper();

         try {
            var5 = var6.doSelect(var5, 0, 1).getItemValue(0, "settletypeid");
            this.setItemValue(var1, "rectypeid", var5);
         } catch (Exception var13) {
            var13.printStackTrace();
         }

         if ((var7 = this.getItemValue(var1, "agentid")) != null || !var7.equals("")) {
            this.setItemValue(var1, "agentid", "");
            this.setItemValue(var1, "agentopcode", "");
            this.setItemValue(var1, "agentname", "");
         }

         if ((var5 = this.getItemValue(var1, "recmethod")) != null && var5.equals("1")) {
            try {
               RemotesqlHelper var8 = new RemotesqlHelper();
               String var9 = "select * from pub_custom_to_saler_v where customid=" + var3 + " and entryid=" + var4;
               DBTableModel var21;
               if ((var21 = var8.doSelect(var9, 0, 10)) != null && var21.getRowCount() >= 0) {
                  String var11;
                  if (var21.getRowCount() == 1) {
                     String var10 = var21.getItemValue(0, "salerdeptid");
                     var5 = var21.getItemValue(0, "salerid");
                     var16 = var21.getItemValue(0, "saleropcode");
                     var11 = var21.getItemValue(0, "salername");
                     var9 = var21.getItemValue(0, "salerdeptname");
                     if (var10 == null || "".equals(var10)) {
                        var9 = "select * from pub_employee_v where employeeid=" + var5;
                        var10 = (var21 = var8.doSelect(var9, 0, 1)).getItemValue(0, "deptid");
                        var9 = var21.getItemValue(0, "deptname");
                     }

                     this.setItemValue(var1, "presalerid", var5);
                     this.setItemValue(var1, "presaleropcode", var16);
                     this.setItemValue(var1, "presalername", var11);
                     this.setItemValue(var1, "presadeptname", var9);
                     this.setItemValue(var1, "presadeptid", var10);
                  } else {
                     Pub_custom_to_saler_hov var22;
                     (var22 = new Pub_custom_to_saler_hov(true)).setOtherwheres("customid = " + var3 + " and entryid=" + var4);
                     DBTableModel var17;
                     if ((var17 = var22.showDialog(this.frame, "")) == null) {
                        this.setItemValue(var1, "presalerid", "");
                        this.setItemValue(var1, "presaleropcode", "");
                        this.setItemValue(var1, "presalername", "");
                        this.setItemValue(var1, "presadeptname", "");
                        this.setItemValue(var1, "presadeptid", "");
                     } else {
                        var16 = var17.getItemValue(0, "salerid");
                        var11 = var17.getItemValue(0, "saleropcode");
                        var9 = var17.getItemValue(0, "salername");
                        String var20 = var17.getItemValue(0, "salerdeptname");
                        var5 = var17.getItemValue(0, "salerdeptid");
                        this.setItemValue(var1, "presalerid", var16);
                        this.setItemValue(var1, "presaleropcode", var11);
                        this.setItemValue(var1, "presalername", var9);
                        this.setItemValue(var1, "presadeptname", var20);
                        this.setItemValue(var1, "presadeptid", var5);
                     }
                  }
               } else {
                  this.infoMessage("提示", "没有业务员，不可录入总单！");
                  this.setItemValue(var1, "presaleropcode", "");
                  this.setItemValue(var1, "presalername", "");
                  this.setItemValue(var1, "presadeptname", "");
               }
            } catch (Exception var14) {
               var14.printStackTrace();
            }
         }
      } else if (var2.equals("recmethod")) {
         if ("1".equals(var3)) {
            this.getDBColumnDisplayInfo("presaleropcode").setReadonly(false);
            this.setItemValue(var1, "recexptype", "");
            this.setItemValue(var1, "recexpmoney", "");
         } else if ("3".equals(var3)) {
            this.getDBColumnDisplayInfo("presaleropcode").setReadonly(true);
            this.setItemValue(var1, "presaleropcode", "");
            this.setItemValue(var1, "presalername", "");
            this.setItemValue(var1, "presadeptname", "");
            this.setItemValue(var1, "presalerid", "");
            this.setItemValue(var1, "presadeptid", "");
            this.setItemValue(var1, "total", "");
            this.setItemValue(var1, "oldprerecid", "");
         } else if ("2".equals(var3)) {
            this.errorMessage("错误", "您只能选择预收款或者收欠款，不能选择现收类型！");
            this.setItemValue(var1, var2, "");
         }
      } else if ("recexpmoney".equals(var2)) {
         var4 = this.getItemValue(var1, "premoney");
         var5 = this.getItemValue(var1, "recexpmoney");
         this.setItemValue(var1, "total", DecimalHelper.sub(var4, var5, 2));
      } else if ("oldprerecid".equals(var2) && !"".equals(var3)) {
         if ((var4 = this.getItemValue(var1, "fmid")) != null && !var4.equals("")) {
            var5 = "select fmrate from pub_formoney where fmid = " + var3;
            var6 = new RemotesqlHelper();
            DBTableModel var18 = new DBTableModel();

            try {
               var18 = var6.doSelect(var5, 0, 1);
            } catch (Exception var12) {
               var12.printStackTrace();
            }

            if (var18 != null && !var18.equals("")) {
               var5 = var18.getItemValue(0, "fmrate");
               this.setItemValue(var1, "exchange", var5);
            }
         }
      } else if ("premoney".equals(var2)) {
         var4 = this.getItemValue(var1, "recmethod");
         if ("3".equals(var4)) {
            var5 = "".equals(var3) ? "0" : var3;
            var16 = this.getItemValue(var1, "recexpmoney");
            var16 = "".equals(var16) ? "0" : var16;
            this.setItemValue(var1, "total", DecimalHelper.sub(var5, var16, 2));
         }
      } else if ("notesno".equals(var2)) {
         if (var3 != null && !"".equals(var3)) {
            Pub_notes_hov var15 = new Pub_notes_hov();
            var5 = "notestype = 1 and usestatus = 1 and notesno like '" + var3 + "%'";
            var15.setOtherwheres(var5);
            DBTableModel var19;
            if ((var19 = var15.showDialog(this.frame, "承兑票据管理")) == null) {
               return;
            }

            var7 = var19.getItemValue(0, "seqid");
            var5 = var19.getItemValue(0, "notesno");
            this.setItemValue(var1, "notesid", var7);
            this.setItemValue(var1, "notesno", var5);
            this.tableChanged();
         }
      } else if ("total".equals(var2)) {
         var4 = this.getItemValue(var1, "recmethod");
         var5 = this.getItemValue(var1, "oldprerecid");
         if ("1".equals(var4) && var5 != null && !"".equals(var5)) {
            this.setItemValue(var1, "premoney", var3);
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   protected JPanel createSecondtoolbar() {
      JPanel var1 = new JPanel();
      CToolbar var2 = new CToolbar();
      var1.setLayout(new BorderLayout());
      var1.add(var2);
      return NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(var1, "由结算单生成(G)", "由结算单生成", "由结算单生成", 71, this.mdemodel), "自动生成(O)", "自动生成", "自动生成", 79, this.mdemodel), "确定(C)", "确定", "确定", 67, this.mdemodel), "回退确定(B)", "回退确定", "回退确定", 66, this.mdemodel), "预收款作废(X)", "预收款作废", "预收款作废", 88, this.mdemodel), "收款单作废(I)", "收款单作废", "收款单作废", 73, this.mdemodel), "切换独立单元(A)", "切换独立单元", "切换独立单元", 65, this.mdemodel);
   }

   protected String getEditablecolumns(int var1) {
      String var2 = this.getItemValue(var1, "usestatus");
      if (!"2".equals(var2)) {
         return "nothing";
      } else {
         int var3;
         String var4;
         if ((var3 = this.mdemodel.getDetailModel().getDBtableModel().getRowCount()) > 0) {
            var4 = this.getItemValue(var1, "recmethod");
            if ("3".equals(var4)) {
               return "credate,bankbillno,rectypeid,bankopcode,recexptype,recexpmoney,memo,notesno,draftdate,recmanopcode,presaleropcode";
            }

            if ("1".equals(var4)) {
               return "credate,bankbillno,rectypeid,bankopcode,memo,notesno,draftdate,recmanopcode,presaleropcode";
            }
         }

         if (this.getRowCount() > 0 && var1 < this.getRowCount() && var3 <= 0 && "2".equals(var2)) {
            var4 = this.getItemValue(var1, "recmethod");
            if ("3".equals(var4)) {
               return "customopcode,credate,bankbillno,recmethod,rectypeid,bankopcode,recexptype,recexpmoney,presaleropcode,fmopcode,memo,agentopcode,notesno,draftdate,recmanopcode";
            }

            if ("1".equals(var4)) {
               return "customopcode,credate,bankbillno,recmethod,rectypeid,oldprerecid,bankopcode,presaleropcode,total,fmopcode,memo,agentopcode,notesno,draftdate,recmanopcode";
            }
         }

         return super.getEditablecolumns(var1);
      }
   }

   public boolean canInvokehov(String var1) {
      String var2;
      if (var1.equals("customopcode") && !(var2 = this.getItemValue(this.getRow(), "oldprerecid")).equals("") && var2 != null) {
         this.infoMessage("提示", "您已经选择了原预收款单，不能更改客户！");
         return false;
      } else if (var1.equals("fmopcode") && (var2 = this.getItemValue(this.getRow(), "oldprerecid")) != null && !var2.equals("")) {
         this.infoMessage("提示", "您已经选择了原预收款单，不能更改外币！");
         return false;
      } else if (!var1.equals("presaleropcode") || (var2 = this.getItemValue(this.getRow(), "customid")) != null && !var2.equals("")) {
         return super.canInvokehov(var1);
      } else {
         this.infoMessage("提示", "请先选择客户,才能选择业务员！");
         return false;
      }
   }

   protected int on_beforemodify(int var1) {
      this.setFocus("credate");
      return super.on_beforemodify(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("credate");
      super.on_doubleclick(var1, var2);
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid();
      if (var2.equals("presaleropcode")) {
         var2 = this.getItemValue(var1, "customid");
         if ((var3 = this.getItemValue(var1, "entryid")) != null && !var3.equals("")) {
            if (var2 != null && !var2.equals("")) {
               return "customid = " + var2 + " and entryid=" + var3;
            } else {
               this.errorMessage("提示", "请先选择客户");
               return "1=2";
            }
         } else {
            this.errorMessage("提示", "没有独立单元");
            return "1=2";
         }
      } else if (!var2.equals("oldprerecid")) {
         if (var2.equals("agentopcode")) {
            if (!(var2 = this.getItemValue(var1, "customid")).equals("") && var2 != null) {
               return " type=2 and companyid=" + var2 + " and (entryid is null or entryid=" + var3 + ")";
            } else {
               this.infoMessage("提示！", "请选择客户！");
               return " 1>2";
            }
         } else if (var2.equals("agentid")) {
            return " type=2 and (entryid is null or entryid=" + var3 + ")";
         } else {
            return var2.equals("presalerid") ? "entryid=" + var3 : super.getHovOtherWheres(var1, var2);
         }
      } else if ((var2 = this.getItemValue(var1, "customid")) != null && var2.length() != 0) {
         String var4;
         if ((var4 = this.getItemValue(var1, "agentid")) == null || var4.equals("")) {
            var4 = "-1";
         }

         return "customid = " + var2 + " and entryid = " + ((Bms_sa_rec_mde)this.mdemodel).getEntryid() + " and nvl(agentid,-1)=" + var4 + " and not exists (select * from bms_sa_rec_doc a   where nvl(a.premoney,0)+nvl(a.recexpmoney,0)>=nvl(total,0) " + " and bms_sa_rec_doc_hov_v.sarecid = a.sarecid )";
      } else {
         this.infoMessage("提示！", "请先确定客户！");
         return null;
      }
   }

   protected String getOtherWheres() {
      String var1;
      if ((var1 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid()) != null && var1.length() != 0) {
         var1 = "entryid = " + var1;
         return var1 + super.getOtherWheres();
      } else {
         this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能操作！");
         return null;
      }
   }

   public void setItemValue(int var1, String var2, String var3) {
      if (var2.equals("premoney")) {
         this.on_itemvaluechange(var1, "premoney", var3);
      }

      super.setItemValue(var1, var2, var3);
   }
}
